#include <stdio.h>
#include <stdlib.h>

#include "utils.h"
#include "prologin.h"

/* fonctions bidons */
int getx()  {
  return position_leucocyte_x(mon_identifiant());
}

int gety()  {
  return position_leucocyte_y(mon_identifiant());
}

int isat(int x, int y) {
  log("is at pos %dx%d comp %dx%d\n", getx(), gety(), x, y);
  return getx() == x && gety() == y;
}

int mid(double i) {
  return (int) (i / 2.L);
}

int minmax(int min, int v, int max) {
  if(v < min)
    return 0;
  if(v >= max)
    return max - 1;
  return v;
}

/* wrapper clean */
int deplace(int x, int y) {
  int lx, ly;

  lx = x = minmax(0, x, taille_corps_x());
  ly = y = minmax(0, y, taille_corps_y());
  log("est en position %dx%d\n", getx(), gety());
  int rv = deplace_leucocyte(x,y);
  log("se deplace en %dx%d rv %d\n", x, y, rv);
  return rv;
}

/* le phagocyter si il est atteignable, sinon on se bouge */
int phago(int x, int y) {
  int rv = regarde(x,y);
  log("phagocyte %dx%d => ", x, y);
  if(rv == VIRUS) {
    int type = virus_type(x, y);
    printf("Virus type %d ", type);
  } else if(identifiant_leucocyte(x,y) != UNKNOWN) {
    int id = identifiant_leucocyte(x,y);
    int tid = equipe(id);
    printf("Leucocyte %d tid %d ",id, tid);
  }

  if(bacteries_presentes(x,y))
    puts("+bacterie");
  else
    puts(" ");

  if(abs(getx() - x) + abs(gety() - y) == 1) {
    log2("attaque ");
    return phagocyte(x, y);
  } else {
    if(abs(getx() - x) ==1 && abs(gety() - y) == 1 && rv == VIRUS)
      /* Alors ce passage est drole, en effet, je me suis rendu
	 que si on est a cote d'un virus en diagonale, il valais
	 mieux le laisser approcher */
      puts("ne rien faire");
    else
      deplace(x, y);

    /* faut bien retourner qq chose */
    return UNKNOWN;
  }
}

/* Mombre de bacteries dans un rectangle */
int check_bacteries_rect(int x1, int y1, int x2, int y2) {
  int rv = 0;
  int i, j;
  for(i = x1; i <= x2; ++i)
    for(j = y1; j <= y2; ++j)
      if(bacteries_presentes(i,j))
	rv++;
  return rv;
}

/* bacteries directement a cote */
int check_bacteries() {
  return check_bacteries_rect(getx() - 1, gety() - 1,
			      getx() + 1, gety() + 1);
}

/* seule fonction "compliquee" du programme,
   avec des vrais bouts de pointeurs a l'interieur */
int plusproche(int *x, int *y, int func(int, int)) {
  int found = 0, min = 0;
  int i, j;
  if(x) *x = -1;
  if(y) *y = -1;

  for(i = getx() - DX_V; i < getx() + DX_V; ++i) {
    for(j = gety() - DX_V; j < gety() + DX_V; ++j) {
      if(func(i, j)) {
	int d = abs(getx() - i) + abs(gety() - j);
	if(!found || d < min) {
	  min = d;
	  if(x) *x = i;
	  if(y) *y = j;
	}
	found++;
      }
    }
  }
  return found;
}
